<?php

namespace App\Models;

// use Illuminate\Contracts\Auth\MustVerifyEmail;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Foundation\Auth\User as Authenticatable;
use Illuminate\Notifications\Notifiable;
use Spatie\Permission\Traits\HasRoles;
use Laravel\Sanctum\HasApiTokens;

class User extends Authenticatable 
implements \Illuminate\Contracts\Auth\MustVerifyEmail
{
    /** @use HasFactory<\Database\Factories\UserFactory> */
    use HasFactory, Notifiable;
    use HasRoles;
    use HasApiTokens;

    /**
     * The attributes that are mass assignable.
     *
     * @var list<string>
     */
    protected $fillable = [
        'name',
        'email',
        'password',
    ];

    /**
     * The attributes that should be hidden for serialization.
     *
     * @var list<string>
     */
    protected $hidden = [
        'password',
        'remember_token',
    ];

    /**
     * Get the attributes that should be cast.
     *
     * @return array<string, string>
     */
    protected function casts(): array
    {
        return [
            'email_verified_at' => 'datetime',
            'password' => 'hashed',
        ];
    }

    public function blogs()
    {
        return $this->hasMany(Blog::class);
    }

    public function orderPackages()
    {
        return $this->hasMany(OrderPackage::class);
    }

    public function topUps()
    {
        return $this->hasMany(TopUp::class);
    }

    public function orderProducts()
    {
        return $this->hasMany(OrderProduct::class);
    }


    public function coupons()
    {
        return $this->hasMany(Coupon::class);
    }

    public function creditCoupons()
    {
        return $this->hasMany(CreditCoupon::class);
    }
    // app/Models/User.php

    public function wallet()
    {
        return $this->hasOne(\App\Models\Wallet::class);
    }

    public function getWalletBalanceAttribute()
    {
        return $this->wallet?->balance ?? 0;
    }
}
